/********************************************************/
/*                                                      */
/* CONCURR1.CMD - IBM Object REXX Sample Program        */
/*                                                      */
/* Sample program to demonstrate default concurrency    */
/* available in Object REXX (inter object concurrency)  */
/*                                                      */
/* ---------------------------------------------------- */
/* (C) Copyright IBM Corp. 1997 - All Rights Reserved.  */
/*                                                      */
/* DISCLAIMER OF WARRANTIES.  The following [enclosed]  */
/* code is sample code created by IBM Corporation. This */
/* sample code is not part of any standard or IBM       */
/* product and is provided to you solely for the        */
/* purpose of assisting you in the development of your  */
/* applications.  The code is provided "AS IS", without */
/* warranty of any kind.  IBM shall not be liable for   */
/* any damages arising out of your use of the sample    */
/* code,  even if they have been advised of the         */
/* possibility of such damages.                         */
/*                                                      */
/********************************************************/
myObj1 = .Repeater1~new
myObj2 = .Repeater1~new
myObj3 = .Repeater2~new
myObj1~Start("Repeat", 5, "Object 1")
myObj2~Start("Repeat", 5, "Object 2")
myObj3~Repeat(5, "Object 3, Invocation A")
myObj3~Repeat(5, "Object 3, Invocation B")

::CLASS Repeater1
::METHOD Repeat
  Use Arg Count, Message
  Say "Starting output of message:" Message
  Do Count
    Say Message
    Call SysSleep 1
  End

::CLASS Repeater2
::METHOD Repeat
  Use Arg Count, Message
  Say "Starting output of message:" Message
  Reply /* return to caller immediately */
  Do Count
    Say Message
    Call SysSleep 1
  End
